package Sophos::SAVI;

use strict;
use warnings;

use base qw(Exporter);
use Carp qw(croak);

our $VERSION = '5.509';
our @EXPORT_OK = qw(get_savi);

sub get_savi {
    my $config = shift;
    my %args = @_;

    my ($dir, %opts);

    $opts{notify}       = $args{notify}       if $args{notify};

    while(my ($k, $v) = each %$config) {
	next if ($k eq 'enabled') or ($k eq 'daemon');
	($dir = $v, next) if $k eq 'datadir';
	$opts{$k} = $v if defined $v;
    }

    require PureMessage::Logger;
    $opts{logger} = PureMessage::Logger->new(ident => 'Sophos-SAVI');

    my %RANK = (
	GrpSuper => 2,
	GrpArchiveUnpack => 1,
	GrpSelfExtract => 1,
	GrpExecutable => 1,
	GrpInternet => 1,
	GrpMSOffice => 1,
	GrpMisc =>1,
	GrpDisinfect => 1,
	GrpClean => 1,
    );

    my @opts = map { $_ => $opts{$_} }
	sort { ($RANK{$b} || 0) <=> ($RANK{$a} || 0) || ($a cmp $b) }
	keys %opts;

    require Sophos::SAVI::Engine;
    Sophos::SAVI::Engine->new($dir, @opts);
}

1;
